//import haxe.io.Bytes;
import haxe.Firebug;
import org.xiph.system.Bytes;

import flash.Vector;

import org.xiph.fogg.SyncState;
import org.xiph.fogg.StreamState;
import org.xiph.fogg.Page;
import org.xiph.fogg.Packet;

import org.xiph.fvorbis.Info;
import org.xiph.fvorbis.Comment;
import org.xiph.fvorbis.DspState;
import org.xiph.fvorbis.Block;

class FOggExample2 {
    var ul : flash.net.URLLoader;

    function try_ogg() : Void {
        var data : Bytes = ul.data;
        data.position = 0;
        var data_pos = 0;

        var oy = new SyncState();
        var os = new StreamState();

        var og = new Page();
        var op = new Packet();

        var vi = new Info();
        var vc = new Comment();
        var vd = new DspState();
        var vb = new Block(vd);

        var buffer : Bytes;
        var bytes = 0;

        var found_pages = 0;
        var found_packets = 0;

        oy.init();

        while (true) {
            var eos = 0;

            var index = oy.buffer(4096);
            buffer = oy.data;

            var to_read = data.bytesAvailable;
            if (to_read > 4096) {
                to_read = 4096;
            }
            data.readBytes(buffer, index, to_read);
            bytes = to_read;

            oy.wrote(bytes);
            //trace("----   mark 1  ----");

            var ret : Null<Int> = null;
            if ((ret = oy.pageout(og)) != 1) {
                trace("----   mark 2  ----");
                trace('' + ret + ', ' + bytes + ', ' +
                      data.bytesAvailable + ', ' + data.length);
                if (bytes < 4096) {
                    break;
                }
                trace('muzik is not an ogg...?!?');
                throw "Exit";
            }
            found_pages++;
            //trace("----   mark 3  ----");

            os.init(og.serialno());
            //trace("----   mark 4  ----");

            vi.init();
            vc.init();

            if (os.pagein(og) < 0) {
                trace("Can't read first page!!");
                throw "Exit";
            }
            //trace("----   mark 5  ----");

            if (os.packetout(op) != 1) {
                trace("Can't read the initial header packet!");
                throw "Exit";
            }
            //trace("----   mark 6  ----");
            found_packets++;

            if (vi.synthesis_headerin(vc, op) < 0) {
                trace("No Vorbis audio data!?");
                throw "Exit";
            };

            var i = 0;
            while (i < 2) {
                while (i < 2) {
                    var result = oy.pageout(og);
                    if (result == 0)
                        break;
                    if (result == 1) {
                        found_pages++;
                        os.pagein(og);
                        while (i < 2) {
                            result = os.packetout(op);
                            if (result == 0)
                                break;
                            if (result == -1) {
                                trace("Corrupt secondary header, yo!");
                                throw "Exit";
                            }
                            vi.synthesis_headerin(vc, op);
                            found_packets++;
                            i++;
                        }
                    }
                }
                index = oy.buffer(4096);
                buffer = oy.data;

                to_read = data.bytesAvailable;
                if (to_read > 4096) {
                    to_read = 4096;
                }
                data.readBytes(buffer, index, to_read);
                bytes = to_read;

                if (bytes == 0 && i < 2) {
                    trace("I'm not looking but where are the Vorbis headers!?");
                    throw "Exit";
                }

                oy.wrote(bytes);
            }
            
            var ptr : Vector<Bytes> = vc.user_comments;
            // for-while;
            var j : Int = 0;
            while (j < ptr.length) {
                if (ptr[j] == null) {
                    break;
                };
                //trace(String(ptr[j], 0, ptr[j].length - 1));
                trace(ptr[j]);
                j++;
            };

            trace("\nBitstream is " + vi.channels + " channel, " +
                  vi.rate + "Hz");
            //trace(("Encoded by: " + String(vc.vendor, 0, vc.vendor.length - 1)) + "\n");
            trace("Encoded by: " + vc.vendor + "\n");

            //?! DecodeExample.convsize = (4096 / vi.channels);
            vd.synthesis_init(vi);
            vb.init(vd);
            var _pcm : Array<Array<Vector<Float>>> = new Array();
            var _index : Vector<Int> = new Vector(vi.channels, true);

            
            while (eos == 0) {
                while (eos == 0) {
                    var result = oy.pageout(og);
                    if (result == 0)
                        break;
                    if (result == -1) {
                        trace("Ooops, a crackle! Moving on...");
                    } else {
                        found_pages++;
                        os.pagein(og);

                        while (true) {
                            result = os.packetout(op);

                            if (result == 0)
                                break;
                            if (result == -1) {
                            } else {
                                // process packets here!
                                found_packets++;
                            }
                        }
                        if (og.eos() != 0)
                            eos = 1;
                    }
                }
                if (eos == 0) {
                    index = oy.buffer(4096);
                    buffer = oy.data;

                    to_read = data.bytesAvailable;
                    if (to_read > 4096) {
                        to_read = 4096;
                    }
                    data.readBytes(buffer, index, to_read);
                    bytes = to_read;

                    oy.wrote(bytes);
                    if (bytes == 0)
                        eos = 1;
                }
            }
        }
        trace("----   mark 7! ----");
        trace("Reading './b.ogg' done.");
        trace("Found " + found_pages + " pages with " + found_packets +
              " packets.");
    }

    function load_complete(evt : flash.events.Event) : Void {
        try_ogg();
    }

    function start_request(url : String) : Void {
        ul = new flash.net.URLLoader();
        ul.dataFormat = flash.net.URLLoaderDataFormat.BINARY;
        ul.addEventListener(flash.events.Event.COMPLETE, load_complete);
        ul.load(new flash.net.URLRequest(url));
    }

    public static function main() : Void {
        if (Firebug.detect() && false) {
            Firebug.redirectTraces();
        }

        var obj = new FOggExample2();
        obj.start_request("b.ogg");
    }

    private function new() {
    }
}
