package test;

import flash.Vector;

import haxe.unit.TestCase;

class TestVectorTools extends TestCase {

    public function test_vectorcopy() {
        var a : Vector<Int> = new Vector(8, true);
        var b : Vector<Int> = new Vector(8, true);
        var c : Vector<Int>;

        var _t : Array<Int> = [0, 1, 2, 3, 4, 5, 6, 7];
        for (i in 0..._t.length) {
            a[i] = _t[i];
        }

        _t = [8, 9, 10, 11, 12, 13, 14, 15];
        for (i in 0..._t.length) {
            b[i] = _t[i];
        }

        c = a.slice();
        c.fixed = true;

        var v : Array<Int> = [0, 1, 2, 2, 3, 4, 5, 7];

        VectorTools.vectorcopy(a, 2, c, 3, 4);
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        VectorTools.vectorcopy(a, 2, c, 0, 6);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        VectorTools.vectorcopy(a, 0, c, 2, 6);
        v = [0, 1, 0, 1, 2, 3, 4, 5];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        VectorTools.vectorcopy(b, 0, c, 0, 8);
        v = [8, 9, 10, 11, 12, 13, 14, 15];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        VectorTools.vectorcopy(b, 0, c, 0, 5);
        v = [8, 9, 10, 11, 12, 5, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        VectorTools.vectorcopy(c, 2, c, 0, 6);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }
    }

    public function test_copyI() {
        var a : Vector<Int> = new Vector(8, true);
        var b : Vector<Int> = new Vector(8, true);
        var c : Vector<Int>;
        var t : Vector<Int>;

        var _t : Array<Int> = [0, 1, 2, 3, 4, 5, 6, 7];
        for (i in 0..._t.length) {
            a[i] = _t[i];
        }

        _t = [8, 9, 10, 11, 12, 13, 14, 15];
        for (i in 0..._t.length) {
            b[i] = _t[i];
        }

        c = a.slice();
        c.fixed = true;

        var v : Array<Int> = [0, 1, 2, 2, 3, 4, 5, 7];

        VectorTools.vectorcopyI(a, 2, c, 3, 4);
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyI(a, 2, c, 0, 6);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyI(a, 0, c, 2, 6);
        v = [0, 1, 0, 1, 2, 3, 4, 5];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyI(b, 0, c, 0, 8);
        v = [8, 9, 10, 11, 12, 13, 14, 15];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyI(b, 0, c, 0, 5);
        v = [8, 9, 10, 11, 12, 5, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyI(c, 2, c, 0, 6);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        /* not in-place copy ... */
        c = a.slice();
        c.fixed = true;
        t = VectorTools.copyI(a, 2, c, 3, 4);
        assertEquals(8, t.length);
        v = [0, 1, 2, 2, 3, 4, 5, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyI(a, 2, c, 0, 6);
        assertEquals(8, t.length);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyI(a, 0, c, 2, 6);
        assertEquals(8, t.length);
        v = [0, 1, 0, 1, 2, 3, 4, 5];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyI(b, 0, c, 0, 8);
        assertEquals(8, t.length);
        v = [8, 9, 10, 11, 12, 13, 14, 15];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyI(b, 0, c, 0, 5);
        assertEquals(8, t.length);
        v = [8, 9, 10, 11, 12, 5, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyI(c, 2, c, 0, 6);
        assertEquals(8, t.length);
        v = [2, 3, 4, 5, 6, 7, 6, 7];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }
    }

    public function test_copyF() {
        var a : Vector<Float> = new Vector(8, true);
        var b : Vector<Float> = new Vector(8, true);
        var c : Vector<Float>;
        var t : Vector<Float>;

        var _t : Array<Float> = [0.0, 1.1, 2.1, 3.1, 4.1, 5.1, 6.1, 7.1];
        for (i in 0..._t.length) {
            a[i] = _t[i];
        }

        _t = [8.1, 9.1, 10.1, 11.1, 12.1, 13.1, 14.1, 15.1];
        for (i in 0..._t.length) {
            b[i] = _t[i];
        }

        c = a.slice();
        c.fixed = true;

        var v : Array<Float> = [0.0, 1.1, 2.1, 2.1, 3.1, 4.1, 5.1, 7.1];

        VectorTools.vectorcopyF(a, 2, c, 3, 4);
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyF(a, 2, c, 0, 6);
        v = [2.1, 3.1, 4.1, 5.1, 6.1, 7.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyF(a, 0, c, 2, 6);
        v = [0.0, 1.1, 0.0, 1.1, 2.1, 3.1, 4.1, 5.1];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyF(b, 0, c, 0, 8);
        v = [8.1, 9.1, 10.1, 11.1, 12.1, 13.1, 14.1, 15.1];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyF(b, 0, c, 0, 5);
        v = [8.1, 9.1, 10.1, 11.1, 12.1, 5.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        c = a.slice();
        c.fixed = true;
        VectorTools.vectorcopyF(c, 2, c, 0, 6);
        v = [2.1, 3.1, 4.1, 5.1, 6.1, 7.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], c[i]);
        }

        /* not in-place copy ... */
        c = a.slice();
        c.fixed = true;
        t = VectorTools.copyF(a, 2, c, 3, 4);
        assertEquals(8, t.length);
        v = [0.0, 1.1, 2.1, 2.1, 3.1, 4.1, 5.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyF(a, 2, c, 0, 6);
        assertEquals(8, t.length);
        v = [2.1, 3.1, 4.1, 5.1, 6.1, 7.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyF(a, 0, c, 2, 6);
        assertEquals(8, t.length);
        v = [0.0, 1.1, 0.0, 1.1, 2.1, 3.1, 4.1, 5.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyF(b, 0, c, 0, 8);
        assertEquals(8, t.length);
        v = [8.1, 9.1, 10.1, 11.1, 12.1, 13.1, 14.1, 15.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyF(b, 0, c, 0, 5);
        assertEquals(8, t.length);
        v = [8.1, 9.1, 10.1, 11.1, 12.1, 5.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }

        t = VectorTools.copyF(c, 2, c, 0, 6);
        assertEquals(8, t.length);
        v = [2.1, 3.1, 4.1, 5.1, 6.1, 7.1, 6.1, 7.1];
        for (i in 0...v.length) {
            assertEquals(v[i], t[i]);
        }
    }
}
